package fr.uca.iut.clfreville2.teaiswarm

import android.content.Intent
import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import androidx.fragment.app.Fragment
import androidx.fragment.app.FragmentFactory
import androidx.fragment.app.commit
import fr.uca.iut.clfreville2.teaiswarm.fragment.RepositoryListFragment
import fr.uca.iut.clfreville2.teaiswarm.model.Repository

const val REPOSITORY_OWNER = "repository_owner"
const val REPOSITORY_NAME = "repository_name"

class MainActivity : AppCompatActivity() {

    override fun onCreate(savedInstanceState: Bundle?) {
        supportFragmentManager.fragmentFactory = RepositoryListFragmentFactory { repo ->
            adapterOnClick(repo)
        }
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)
        supportFragmentManager.commit {
            setReorderingAllowed(true)
            replace(R.id.fragment_container_view, RepositoryListFragment::class.java, null)
        }
    }

    private fun adapterOnClick(repository: Repository) {
        val intent = Intent(this, RepositoryDetailActivity()::class.java)
        intent.putExtra(REPOSITORY_OWNER, repository.owner.login)
        intent.putExtra(REPOSITORY_NAME, repository.name)
        startActivity(intent)
    }

    class RepositoryListFragmentFactory(private val onClick: (Repository) -> Unit) : FragmentFactory() {
        override fun instantiate(classLoader: ClassLoader, className: String): Fragment {
            if (className == RepositoryListFragment::class.java.name) {
                return RepositoryListFragment("clement.freville2", onClick);
            }
            return super.instantiate(classLoader, className)
        }
    }
}